package core

import (
	"git.noahlan.cn/noahlan/nnet/entity"
	"git.noahlan.cn/noahlan/nnet/packet"
)

type (
	Handler interface {
		Handle(entity entity.NetworkEntity, pkg packet.IPacket)
	}

	HandlerFunc func(entity entity.NetworkEntity, pkg packet.IPacket)

	Middleware func(next HandlerFunc) HandlerFunc
)

func (f HandlerFunc) Handle(entity entity.NetworkEntity, pkg packet.IPacket) {
	f(entity, pkg)
}
